stages:
  - build-push-image
  - linter
  - test
  - push-platform-deployment

build-push-image:
  stage: build-push-image
  image: docker:19
  services:
    - docker:dind
  script:
    - echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY
    - docker pull $CI_REGISTRY_IMAGE:latest || true
    - >
      docker build
      --pull
      --cache-from $CI_REGISTRY_IMAGE:latest
      --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
      .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - > 
      if [ "$CI_COMMIT_REF_NAME" == "$CI_DEFAULT_BRANCH" ]; then
        docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA $CI_REGISTRY_IMAGE:latest && 
        docker push $CI_REGISTRY_IMAGE:latest
      else
        docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME && 
        docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
      fi

Flake8:
  stage: linter
  only:
    - merge_requests
  allow_failure: true
  image: python:3.10.1-alpine3.15
  script:
    - pip install flake8
    - flake8 --max-line-length=180

sast:
  stage: test
include:
- template: Security/SAST.gitlab-ci.yml
- template: Security/Secret-Detection.gitlab-ci.yml

push-platform-deployment:
  stage: push-platform-deployment
  image: registry.gitlab.com/greece-vs-corona/deployment/git-kustomize:2.34.1-4.4.1
  rules:
    - if: $CI_COMMIT_REF_PROTECTED == "true"
  retry: 1
  script:
    ##
    ## Start ssh-agent (inside the build environment)
    ##
    - eval $(ssh-agent -s)

    ## SSH_PRIVATE_KEY_ENC is the private key encoded with "cat key | base64 -w0"
    - echo "$SSH_PRIVATE_KEY_ENC" | base64 --decode | ssh-add -

    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh

    ##
    ## Use ssh-keyscan to scan the keys of your private server. Replace gitlab.com
    ## with your own domain name. You can copy and repeat that command if you have
    ## more than one server to connect to.
    ##
    - ssh-keyscan gitlab.com >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts

    - git config --global user.email "ci@clinical-data-service.gitlab-repo.com"
    - git config --global user.name "ci-clinical-data-service"

    - git clone git@gitlab.com:greece-vs-corona/deployment/platform-deployment-k8s-resources.git

    - cd platform-deployment-k8s-resources/clinical-data-service/overlays/

    - >
      if [ "$CI_COMMIT_REF_NAME" == "$CI_DEFAULT_BRANCH" ]; then
        cd staging/
        kustomize edit set image registry.gitlab.com/greece-vs-corona/deployment/clinical-data-service=registry.gitlab.com/greece-vs-corona/deployment/clinical-data-service:$CI_COMMIT_SHA
      else
        cd production/
        kustomize edit set image registry.gitlab.com/greece-vs-corona/deployment/clinical-data-service=registry.gitlab.com/greece-vs-corona/deployment/clinical-data-service:$CI_COMMIT_REF_NAME
      fi

    - kustomize build

    - git add -A

    ## diff-index first to avoid error on nothing to commit
    - git diff-index --quiet HEAD || git commit -m 'auto ci commit to set clinical-data-service image'

    - git push
